com.orsoncharts.data

## Class AbstractDataset3D

- java.lang.Object
- - com.orsoncharts.data.AbstractDataset3D

- All Implemented Interfaces:
    Dataset3D
  Direct Known Subclasses:
    StandardCategoryDataset3D, StandardPieDataset3D, XYZSeriesCollection

      public class AbstractDataset3D
      extends java.lang.Object
      implements Dataset3D

  A base class that can be used to create new dataset classes.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractDataset3D()` Default constructor - allocates storage for listeners that can be registered with the dataset.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addChangeListener(Dataset3DChangeListener listener)` Registers an object to receive notification of changes to the dataset.
    `protected void` | `fireChangeEvent()` Sends a `Dataset3DChangeEvent` to all registered listeners, unless the `notify` flag is set to `false` in which case this method does nothing.
    `protected void` | `fireDatasetChanged()` Notifies all registered listeners that the dataset has changed.
    `boolean` | `hasListener(java.util.EventListener listener)` Returns `true` if the specified object is registered with the dataset as a listener.
    `boolean` | `isNotify()` Returns a flag that controls whether or not change events are sent to registered listeners.
    `protected void` | `notifyListeners(Dataset3DChangeEvent event)` Notifies all registered listeners that the dataset has changed, unless the `notify` flag is set to `false` in which case this method does nothing.
    `void` | `removeChangeListener(Dataset3DChangeListener listener)` Deregisters an object so that it no longer receives notification of changes to the dataset.
    `void` | `setNotify(boolean notify)` Sets a flag that controls whether or not listeners receive `Dataset3DChangeEvent` notifications.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractDataset3D

          protected AbstractDataset3D()

      Default constructor - allocates storage for listeners that can be registered with the dataset.

  - ### Method Detail

    - #### isNotify

          public boolean isNotify()

      Returns a flag that controls whether or not change events are sent to registered listeners.
      Returns:
        A boolean.
      See Also:
        `setNotify(boolean)`

    - #### setNotify

          public void setNotify(boolean notify)

      Sets a flag that controls whether or not listeners receive `Dataset3DChangeEvent` notifications.
      Parameters:
        `notify` - a boolean.
      See Also:
        `isNotify()`

    - #### addChangeListener

          public void addChangeListener(Dataset3DChangeListener listener)

      Registers an object to receive notification of changes to the dataset.
      Specified by:
        `addChangeListener` in interface `Dataset3D`
      Parameters:
        `listener` - the object to register.
      See Also:
        `removeChangeListener(Dataset3DChangeListener)`

    - #### removeChangeListener

          public void removeChangeListener(Dataset3DChangeListener listener)

      Deregisters an object so that it no longer receives notification of changes to the dataset.
      Specified by:
        `removeChangeListener` in interface `Dataset3D`
      Parameters:
        `listener` - the object to deregister.
      See Also:
        `addChangeListener(Dataset3DChangeListener)`

    - #### hasListener

          public boolean hasListener(java.util.EventListener listener)

      Returns `true` if the specified object is registered with the dataset as a listener. Most applications won't need to call this method, it exists mainly for use by unit testing code.
      Specified by:
        `hasListener` in interface `Dataset3D`
      Parameters:
        `listener` - the listener.
      Returns:
        A boolean.
      See Also:
        `addChangeListener(Dataset3DChangeListener)`, `removeChangeListener(Dataset3DChangeListener)`

    - #### fireDatasetChanged

          protected void fireDatasetChanged()

      Notifies all registered listeners that the dataset has changed.
      See Also:
        `addChangeListener(Dataset3DChangeListener)`

    - #### notifyListeners

          protected void notifyListeners(Dataset3DChangeEvent event)

      Notifies all registered listeners that the dataset has changed, unless the `notify` flag is set to `false` in which case this method does nothing.
      Parameters:
        `event` - contains information about the event that triggered the notification.
      See Also:
        `addChangeListener(Dataset3DChangeListener)`, `removeChangeListener(Dataset3DChangeListener)`

    - #### fireChangeEvent

          protected void fireChangeEvent()

      Sends a `Dataset3DChangeEvent` to all registered listeners, unless the `notify` flag is set to `false` in which case this method does nothing.